/* eslint-disable no-prototype-builtins */
const axios = require('axios');

/**
 * @return {boolean}
 */
function isJsonString(str) {
    try {
        JSON.parse(str);
    } catch (e) {
        return false;
    }
    return true;
}

function checkIfRequestHasVote(json) {
    console.log("Has Vote: " + JSON.parse(json).hasOwnProperty('vote'), json);
    return JSON.parse(json).hasOwnProperty('vote');
}

function sendRequest(url, json, callback) {
    //make post request
    axios
        .post(url, JSON.parse(json))
        .then(res => {
            //echo data
            callback(res);
        })
        .catch(error => {
            console.error(error);
            callback(null);
        });
}

function addMapToClient(clientList, currentClient, mapId, callback) {
    clientList.forEach(client => {
        if (client.name === currentClient.name) {
            client.mapId = mapId;
            console.log("Client Map ID found");
        }
    });
    return callback(clientList);
}

module.exports = {
    isJsonString,
    checkIfRequestHasVote,
    sendRequest,
    addMapToClient
};
